include("../classes/player.lua");

-- =============================================================================
-- =====================  Character Attributes   ===============================

-- BankRental function, if your bags are full, than you can moving the items in branch bank
-- If Bank = 0 than the character isn't using the bank
-- Bank: 1. digit = the first usable branch bank
-- Bank: 2. digit = it's show that, how many branches bank are usable from the first usable branch bank
-- Pet = pet slot location, if you haven't got pets then pet = 0
-- usableSlot = the first sellable slot location in the bags
-- AltName = It s shows Which alt character you want to invite

charAttrTable ={
			[1] = {Bank=33,Pet=2,usableSlot=4,pName="Main1",			AltName="Alt1"},
			[2] = {Bank=23,Pet=2,usableSlot=2,pName="Main2",			AltName="Alt2"},
			[3] = {Bank=22,Pet=1,usableSlot=3,pName="Main3",			AltName="Alt3"},
			[4] = {Bank=22,Pet=2,usableSlot=2,pName="Main4",			AltName="Alt4"},
			[5] = {Bank=00,Pet=2,usableSlot=5,pName="Main5",			AltName="Alt5"},
			[6] = {Bank=00,Pet=1,usableSlot=2,pName="Main6",			AltName="Alt6"},
			[7] = {Bank=00,Pet=2,usableSlot=1,pName="Main7",			AltName="Alt7"},
			[8] = {Bank=00,Pet=0,usableSlot=7,pName="Main8",			AltName="Alt8"},
			[9] = {Bank=00,Pet=1,usableSlot=3,pName="Main9",			AltName="Alt9"},
			
			[10] ={Bank=00,Pet=0,usableSlot=3,pName="MainCharOther02",		AltName=""},
			[11] ={Bank=00,Pet=0,usableSlot=3,pName="MainCharOther03",		AltName=""},
			[12] ={Bank=00,Pet=0,usableSlot=3,pName="MainCharOther04",		AltName=""},
			[13] ={Bank=00,Pet=0,usableSlot=3,pName="MainCharOther05",		AltName=""},
			[14] ={Bank=00,Pet=0,usableSlot=3,pName="MainCharOther06",		AltName=""}
			}
			
function charAttrGet(Attr)			
	for __, option in pairs(charAttrTable) do
		if player.Name == option.pName 		then
			if 		Attr == "Bank" 			then return option.Bank
			elseif 	Attr == "Pet" 			then return option.Pet
			elseif 	Attr == "usableSlot" 	then return option.usableSlot
			elseif 	Attr == "AltName" 		then return option.AltName
			end
		end
	end
end

function myKill()
	RoMScript('KillSequence("","KS");');	--use it what you want( you need to setup are yours characters by the same !)
	--keyboardPress(key.VK_A);
	--player:fight();
end

function potionControl()
	useHousemaidPotions("speed");
	useHousemaidPotions("clearThought");
	useHousemaidPotions("luck");
	if player.Class1 == CLASS_SCOUT then Arrows();end;
------------------ buffs  -----------------------------------------
	if 		player.Class1 == CLASS_SCOUT 	then
		getupBuff("Frost Arrow")
	elseif	player.Class1 == CLASS_MAGE and player.Class2 == CLASS_PRIEST	then
		getupBuff("Magic Barrier");
		getupBuff("Essence of Magic");
		getupBuff("Fire Ward");
		getupBuff("Blessed Spring Water");
	elseif	player.Class1 == CLASS_KNIGHT 	then
		getupBuff("Enhanced Armor");
		getupBuff("Holy Seal");
	elseif	player.Class1 == CLASS_CHAMPION then
		getupBuff("Forge");
	elseif	player.Class1 == CLASS_ROGUE 	then
		getupBuff("Combat Master");
		if not player:hasBuff("Poisonous") and inventory:itemTotalCount("Poison Bottle") >= 1 then
			getupBuff("Poison");
		end;		
	elseif	player.Class1 == CLASS_PRIEST 	then
	elseif	player.Class1 == CLASS_WARRIOR 	then
	elseif	player.Class1 == CLASS_WARLOCK 	then
	end;
------------------ Magic Parfum control, pet recall -------------
	local petSlot=charAttrGet("Pet")
	local mypet= CEggPet(petSlot);
	if ( petSlot ~=0 and player:hasBuff("Magic Perfume") ) then
		if  settings.profile.options.LOOT_DISTANCE > 70  then	changeProfileOption("LOOT_DISTANCE", 60);end;
		if not sendMacro('IsPetSummoned('..petSlot..')') then sendMacro('SummonPet('..petSlot..')');yrest(6000); end;
	end;
end

function Fight(ranges,bossName)	-- fighting with the boss if it is the boss
	local castNo =0
	if bossName ~= nil then
			PingCheck(250,true);
			local objectList = CObjectList();
			objectList:update();
			for i = 0,objectList:size() do
				local obj = objectList:getObject(i);
				if ( obj ~= nil ) then
					local target = obj.Address
					if ( obj.Name == bossName and CPawn(obj.Address).Alive )  then
						player:target(obj)
						player.TargetPtr = obj.Address
						printf("   Boss distance = %s 	-------  ",math.floor (distance(obj.X,obj.Z,player.X,player.Z)) )
						printf("    Boss name= %s \n",obj.Name)
						--printf("Target X= %s,   Z= %s,  Y= %s \n",math.floor(obj.X),math.floor(obj.Z),math.floor(obj.Y))
						--printf("Player X= %s,   Z= %s,  Y= %s \n",math.floor(player.X),math.floor(player.Z),math.floor(player.Y))					
						while  RoMScript('UnitHealth("target")')>0 do
							player:target(obj)
							player.TargetPtr = obj.Address
							lookatTarget(obj.X,obj.Z,obj.Y);
							castNo = castNo+1
							myKill();
							if castNo > 20 then directionChange(back);castNo=0; end;
							yrest(100);
						end						
					end
				end
			end
		yrest(500);
		killAggro(150)		-- after that it kill the mobs whose are in the aggro
	else
		local range = ranges
		if player.Class1 == CLASS_MAGE then
			--player:cast("MAGE_DISCHARGE");
			player:cast("MAGE_PURGATORY_FIRE");		
		elseif player.Class1 == CLASS_KNIGHT then
			player:cast("KNIGHT_WHIRLWIND_SHIELD");
		end;
		killAggro(range)
		PingCheck(250,true);
		killAll(range)
	end
	PingCheck(250,true);lootExtra();player:lootAll();lootEvery();lootExtra();
end

function killAggro(_range)     ------ it kill the mobs whose are in the aggro in range
	if _range == nil then _range = 150 end;
	local height = 40
	local objectList = CObjectList();
	objectList:update();
	for i = 0,objectList:size() do
		local obj = objectList:getObject(i);
		if( obj ~= nil ) then
			local pawn = CPawn(obj.Address);
			if pawn.TargetPtr == player.Address then			
			local target = obj.Address
				if (   obj.Address ~= player.Address and obj.Address ~= player.Pet.Address
					and _range >= math.abs(math.floor (distance(obj.X,obj.Z,player.X,player.Z)))
					and height >= math.abs (math.floor(obj.Y-player.Y)) )  then
					local target = obj.Address					
					if   (   RoMScript('UnitCanAttack("player","target")') and ( CPawn(obj.Address).Alive) and RoMScript('UnitHealth("target")')>0   ) then
						player:target(obj)
						player.TargetPtr = obj.Address
							printf("   Aggro target distance = %s ------- ",math.floor (distance(obj.X,obj.Z,player.X,player.Z)) )
							printf("Target name= %s \n",obj.Name)
							--printf("Target X= %s,   Z= %s,  Y= %s \n",math.floor(obj.X),math.floor(obj.Z),math.floor(obj.Y))
							--printf("Player X= %s,   Z= %s,  Y= %s \n",math.floor(player.X),math.floor(player.Z),math.floor(player.Y))
							local castNo =0;
							while  (  RoMScript('UnitCanAttack("player","target")') and  ( CPawn(obj.Address).Alive) and RoMScript('UnitHealth("target")')>0   ) do
								lookatTarget(obj.X,obj.Z,obj.Y);
								castNo = castNo+1
								myKill();
								if castNo > 6 then directionChange(back);castNo=0; end;
								yrest(200);
							end      	
					end
				end
			end
		end
	end   
end


function killAll(_range)     ------ after that the other mobs (Kill all mob in range)
	local killable = true;
	local height = 40
	local objectList = CObjectList();
	objectList:update();
	for i = 0,objectList:size() do
		local obj = objectList:getObject(i);
		if( obj ~= nil ) then
			if (   obj.Address ~= player.Address and obj.Address ~= player.Pet.Address
				and _range >= math.abs(math.floor (distance(obj.X,obj.Z,player.X,player.Z)))
				and height >= math.abs (math.floor(obj.Y-player.Y)) and ( CPawn(obj.Address).Alive)  )  then
				--printf("\n Target rel.height= %s \n",math.abs (math.floor(obj.Y-player.Y)))
				if RoMScript('UnitHealth("target")')~=nil then
					local target = obj.Address
					player:target(obj)
					player.TargetPtr = obj.Address				
					if   (   RoMScript('UnitCanAttack("player","target")') and RoMScript('UnitHealth("target")')>0   ) then
						printf("   Target distance = %s  ------- ",math.floor (distance(obj.X,obj.Z,player.X,player.Z)) )
						printf("Target name= %s \n",obj.Name)
						--printf("Target X= %s,   Z= %s,  Y= %s \n",math.floor(obj.X),math.floor(obj.Z),math.floor(obj.Y))
						--printf("Player X= %s,   Z= %s,  Y= %s \n",math.floor(player.X),math.floor(player.Z),math.floor(player.Y))					
						local castNo=0;
						while  ( killable  and RoMScript('UnitHealth("target")')>0  ) do	--and RoMScript('UnitCanAttack("player","target")') and ( CPawn(obj.Address).Alive) 
							lookatTarget(obj.X,obj.Z,obj.Y);						
							myKill();castNo = castNo+1;
							yrest(200);
							if castNo==10 then killable= false; end;
						end					      	
					end
				end
			end
		end
	end 
end

function CancelBuff(buffname)
    if buffname == nil then
        cprintf(cli.yellow,"No buff specified. Please use 'CancelBuff(buffname)'.\n")
        return false
    end
    local buffnum=1
    local buff=RoMScript("UnitBuff('player',"..buffnum..")");
    while buff ~= nil do
        if buff == buffname then
            sendMacro("CancelPlayerBuff("..buffnum..");")
            return true
        end
        buffnum=buffnum+1
        buff=RoMScript("UnitBuff('player',"..buffnum..")");
    end
    return false
end

function jumping()
		keyboardHold( settings.hotkeys.MOVE_FORWARD.key )
		yrest(450)
		keyboardPress(key.VK_SPACE)
		yrest(200)
		keyboardRelease( settings.hotkeys.MOVE_FORWARD.key )
end

function horseUp()
	yrest(500)
	if (not player.Mounted) then
         player:mount();
         yrest(3500);
         player:update();
	end;
end

function honorControl()
	local zoneid = RoMScript("GetZoneID()");
	if zoneid == 107 then
		if  (not player:hasBuff("May Establish Honor Party") and inventory:itemTotalCount("Teaching Certificate") >= 1) then
			speed (_normal);
			if RoMScript("UnitExists('party1')") then
				player:clearTarget();
				sendMacro("LeaveParty()")
				waitForLoadingScreen(18)
				player:update()
			end;			
			__WPL:setWaypointIndex(__WPL:findWaypointTag("Ress"))
		end;
	end;
end

function bossBuffs()	
		if player.Class1 == CLASS_MAGE and player.Class2 == CLASS_PRIEST then
			player:cast("PRIEST_REGENERATE");yrest(200);
			goSkill("Energy Influx");
			goSkill("Elemental Catalysis");
			--goSkill("Inensification");
		elseif player.Class1 == CLASS_CHAMPION then
			goSkill("Death Arrives");
			goSkill("Rune Growth");
			goSkill("Feedback Defense");
			goSkill("Waiting Game");		
		elseif player.Class1 == CLASS_KNIGHT and player.Class2 == CLASS_WARRIOR then
			player:cast("Charge");yrest(400);
		elseif player.Class1 == CLASS_WARRIOR and player.Class2 == CLASS_KNIGHT then			
		elseif player.Class1 == CLASS_SCOUT then
			goSkill("Arrow of Essence");
		elseif player.Class1 == CLASS_ROGUE then
			--goSkill("Fervent Attack");
			--goSkill("Informer");
			--goSkill("Assassins Rage");
		end	
end

function goSkill(skill)
	if SkillUsable(skill) then
		RoMScript("CastSpellByName(\'"..skill.."\')");
	end;
end

function SkillUsable(SkillName)
	local x = 2
	while(x <= 4)do
		local totalCount = RoMScript("GetNumSkill("..x..")")
		if(totalCount)then
			local y = 1
			while(y <= totalCount) do
				local name, _1, icon, _2, rank, _3, tp_to_upgrade, energy_type, usable = RoMScript("GetSkillDetail("..x..","..y..")")
				if string.lower(name) == string.lower(SkillName) and usable == true then
					totalCD, remainingCD = RoMScript("GetSkillCooldown("..x..","..y..")")
					if(remainingCD <= 1)then
						return true
					end
				end
				y = y + 1
			end
		end
		x = x + 1
	end
	return false
end

function PetFeed()
	local petSlot=charAttrGet("Pet")
	local mypet= CEggPet(petSlot);
	if petSlot ~=0 then
		if mypet.Nourishment < 80 and inventory:itemTotalCount("Miller's Special Cake") > 0 then
			if sendMacro('IsPetSummoned('..petSlot..')') then  sendMacro('ReturnPet('..petSlot..')') end; yrest(500);
			repeat
				mypet:feed("Miller's Special Cake",1) -- 1 at a time is too slow
			until (mypet.Nourishment == 100 or inventory:itemTotalCount("Miller's Special Cake") == 0)
		end
			if sendMacro('IsPetSummoned('..petSlot..')') then  else sendMacro('SummonPet('..petSlot..')');yrest(6000); end;
	end;
end

function getupBuff(_buffName)
local buffName=_buffName;
	if not player:hasBuff(buffName) then
		RoMScript("CastSpellByName(\'"..buffName.."\')");yrest(800);			--player:cast(buffName);
	end;
end

function HealAll()
	if player.Class1 == CLASS_PRIEST or player.Class2 == CLASS_PRIEST then
		PartyTable()
		for i,v in ipairs(partymemberpawn) do
			player:target(partymemberpawn[i])
			player:update()
			partymemberpawn[i]:update()
			partymemberpawn[i]:updateBuffs()
			target = player:getTarget();
			if .80 > target.HP/target.MaxHP then player:cast("PRIEST_URGENT_HEAL");yrest(1100);end;
			if .85 > target.HP/target.MaxHP then player:cast("PRIEST_URGENT_HEAL");yrest(1100);end;
			if ((.95 > target.HP/target.MaxHP) and (not target:hasBuff("Regenerate"))) then player:cast("PRIEST_REGENERATE");end;
		end;
	else
		while   (85 > (player.HP/player.MaxHP*100))  do
		    printf("player    HP =     %s\n", (player.HP/player.MaxHP*100))
		   	if (inventory:itemTotalCount("Mysterious Herb") >= 1) then
				inventory:useItem("Mysterious Herb");
				yrest(400);
			end;
		   player:update()
		end;
	end
end

function InPtyNumber()
	local number=0
	repeat	
	if (GetPartyMemberName(number) ~= nil) then
		if GetPartyMemberName(number) == player.Name then
			return number
		end;
	number = number + 1
	end;
	until number == 5	
end

function bagToMagicbox()		--The important items moving to magicbox (transmutor)
	if not sendMacro('BagFrame:IsVisible()') then
		RoMScript("BagFrame:Show()");
		RoMScript("MagicBoxFrame:Show()");            
	end
	local important = {"Teaching Certificate","Mysterious Herb","Herb of Hope","Infinite Herb","Mysterious Magic Stone","Rare Magic Stone","Infinite Elemental Stone",
	"Potion: Lucky Target","Potion: Unbridled Enthusiasm","Potion: Clear Thought","Potion: Scarlet Love","Potion: Galloping Gale"};
	local n=1;
	repeat
--	printf("Item=  %s important %s. items.\n ", important[n],n);
		if (important[n] ~= nil) then n=n+1 end;
	until (important[n] == nil)
	local importantMax = (n-1);			-- find important MAX itemnumber
--	printf("importantMax itemNo = %s\n ", importantMax);
	for i=1,importantMax do
			inventory:update();			
			item = inventory:findItem(important[i])			
			if (item and (item.SlotNumber > 60) and (inventory:itemTotalCount(0,"magicbox") > 0) ) then
				item:moveTo("magicbox");
				printf("From %s. place, moving in MagicBox at the %s place.\n ",item.SlotNumber, important[i]);
			end;
	end
	RoMScript("MagicBoxFrame:Hide()");
end

function bagDeleting()			--The unimportant items are deleting
	local notImportant = {"Potion: Pungent Vileness","Potion: Fullness","Potion: Princely Look","Potion: Crazy Breakout"};
	local n=1;
	repeat
		if (notImportant[n] ~= nil) then n=n+1 end;
	until (notImportant[n] == nil)
	local notImportantMax = (n-1);
--	printf("notImportant Max item number = %s\n ", notImportantMax);
	for i=1,notImportantMax do
			inventory:update();
			item = inventory:findItem(notImportant[i])
			if (item and (item.SlotNumber > 60)) then
				item:delete();
				printf("From %s. place, a %s deleting.\n ",item.SlotNumber, notImportant[i]);
			end;
	end
end

function bagRendez()
	local firstSlot = charAttrGet("usableSlot");					-- busy by user
	local itemNo = 240-inventory:itemTotalCount(0,"bags")-firstSlot	-- not important
	if itemNo>0 then
		printf("Taska rendezes indul \n");
		local startslot = 60 + firstSlot;
		local finishslot = 120;
		local j =240;
		for i =startslot,finishslot	do								-- back 					
			local item = inventory.BagSlot[i];
			if ((not item.Empty) and item.Available) then
				item:pickup();			
				local item = inventory.BagSlot[j];
				if item.Empty and item.Available then
					item:pickup();j = j-1;
				end
			end
		end
		inventory:update();
		for i = 240,240-itemNo do									-- forward
			local item = inventory.BagSlot[i];
			item:pickup();
			if 		inventory:itemTotalCount(0,"bag1")>1 then item:moveTo("bag1");
			elseif	inventory:itemTotalCount(0,"bag2")>1 then item:moveTo("bag2");
			elseif	inventory:itemTotalCount(0,"bag3")>1 then item:moveTo("bag3");
			elseif	inventory:itemTotalCount(0,"bag4")>1 then item:moveTo("bag4");
			end
		end
	end
end

function unmarketableDel()
   for i, item in pairs(inventory.BagSlot) do
      if item.SlotNumber >= settings.profile.options.INV_AUTOSELL_FROMSLOT + 62 and
      settings.profile.options.INV_AUTOSELL_TOSLOT + 60 >= item.SlotNumber then
								-- item.Name ~= "<EMPTY>"
				-- item = inventory.BagSlot[slot]
				-- if (not item.Empty) and item.Available then printf("%s. %s\n", slot, item.Name);
         if not (item:isType("Monster Cards" and item.Quality > 2) or inventory.BagSlot[item.SlotNumber].Empty) then
            printf("slot =  %s   ", item.SlotNumber);printf("item =  %s\n ", item.Name);item:delete();
         end        
      end
   end
end

function CleanBag(price)
   for i, item in pairs(inventory.BagSlot) do
      if item.SlotNumber >= settings.profile.options.INV_AUTOSELL_FROMSLOT + 60 and
      settings.profile.options.INV_AUTOSELL_TOSLOT + 60 >= item.SlotNumber then
         if item:isType("Runes") then
            printf("slot= %s  price= %s gold  ", item.SlotNumber,item.Worth);printf("item=  %s\n ", item.Name);item:delete();
         end
         if ( item:isType("Weapons") or item:isType("Armor") ) and (price > item.Worth and 3 > item.Quality) then
            printf("slot= %s  price= %s gold  ", item.SlotNumber,item.Worth);printf("item=  %s\n ", item.Name);item:delete();
         end
         if ( item:isType("Monster Cards") and (3 > item.Quality)) then
            printf("slot= %s  price= %s gold  ", item.SlotNumber,item.Worth);printf("item=  %s\n ", item.Name);item:delete();
         end
--         if item.Name  == "Link Rune" then
--            printf("slot= %s  price= %s gold  ", item.SlotNumber,item.Worth);printf("item=  %s\n ", item.Name);item:delete();
--         end
         if item:isType("Potions") and (45 > item.RequiredLvl and item.RequiredLvl > 10) then
            printf("slot= %s  price= %s gold  ", item.SlotNumber,item.Worth);printf("item=  %s\n ", item.Name);item:delete();
         end         
      end
   end
end

function startinHouse()
	house= {}
	n=0
	servantNames={}
	m=0
	local nSpaceCount = RoMScript('Houses_GetFurnitureItemInfo( -1 )');
	for k = 1,nSpaceCount do
		local enable, name, texture, Placed, ID = RoMScript('Houses_GetFurnitureItemInfo('..k..' )');
		if enable then
			n=n+1;
			house[n] = name			
		end		
	end
	printf("\n Finding furniture list .....");
	------------------------
	local objectList = CObjectList();
	objectList:update();
	for i = 0,objectList:size() do
		local obj = objectList:getObject(i);
		if ( obj ~= nil and (obj.Name ~= "Housekeeper") and obj.Name~="" and obj.Address ~= player.Address
			and obj.Address ~= player.Pet.Address  )	then
		--	printf("\n Name=  %s  ", obj.Name );
			for k=1,n do
				if house[k]==obj.Name then
					obj.Name="";--printf("\n NameNew=  %s  ", obj.Name );
				end
			end
		end
	end
	printf("\n Finding object in house .....");
	-----------------------
	for i = 0,objectList:size() do
	local obj = objectList:getObject(i);
		if ( obj ~= nil and (obj.Name ~= "Housekeeper") and obj.Name~="" and obj.Address ~= player.Address
			and obj.Address ~= player.Pet.Address  )	then
			--printf("\n servantNames   = %s ",obj.Name)
			if obj.Name~="<UNKNOWN>" then
			m=m+1;
			servantNames[m]=obj.Name
			end
		end
	end
	printf("\n\n I finds the servants names .....    :\n\n");
	for i=1,m do
		printf("\n servantNames   = %s ",servantNames[i])
	end
	------------------------
	for i=1,m do
		local npc = player:findNearestNameOrId(servantNames[i]);
		if npc~=nil then
			player:moveTo(CWaypoint(npc.X,npc.Z,npc.Y),true);
			printf("\n I crafting from servant %s  ...\n",servantNames[i])
			for j=1,4 do
				player:target_NPC(servantNames[i]);			-- Crafting * 4
				yrest(100);
				ChoiceOptionByName("Crafting");
				yrest(100);
			end;
		end;
	end;	
	local npc = player:findNearestNameOrId("Housekeeper");
	player:moveTo(CWaypoint(npc.X,npc.Z,npc.Y),true);
	yrest(1000);
	player:target_NPC("Housekeeper");
	yrest(500);
	ChoiceOptionByName("Leave the house");
	yrest(500);
	waitForLoadingScreen(10);
	__WPL:setWaypointIndex(__WPL:findWaypointTag("Logar"));
						
end
	
function catchCavy(_cavy)
   local hpper = 50 -- Players hp percent threshhold to give-up catching the cavy
   _cavy = _cavy or 103567 -- Default value "Golden Magic Cavy"
   if string.lower(_cavy) == "cavy" then -- Look for all cavies
      _cavy = {103566,103567}
   end
   local cavy = player:findNearestNameOrId(_cavy, player.IgnoreCavy)
   if not cavy or
      distance(cavy.X, cavy.Z, player.X,player.Z) > settings.profile.options.MAX_TARGET_DIST then
      return -- No cavy, return
   end
   yrest(200); -- Make sure you've come to a complete stop.
   player:update()
   -- Don't catch cavy if still battling.
   if player.Battling  and
      player:findEnemy(true, nil, evalTargetDefault) then
      return
   end
   local function CalcNewPos(_trap, _cavy)
      local HerdDist = 50 -- distance to herd cavy
      local TrapCavyDist = distance(_trap.X, _trap.Z, _cavy.X, _cavy.Z)
      local Ratio = (TrapCavyDist + HerdDist) / TrapCavyDist
      local x = (_cavy.X - _trap.X) * Ratio + _trap.X
      local z = (_cavy.Z - _trap.Z) * Ratio + _trap.Z
      local NewPos = CWaypoint(x, z)
      NewPos.Type = 4 -- Travel
      return NewPos
   end
   if cavy and inventory:useItem(206776) then -- Huntsman's Trap
      cprintf(cli.yellow,"\a\aAttempting to catch cavy...\n")
      yrest(3300)
      player:update()
      trap = {X = player.X, Z = player.Z}
      while true do
         cavy:update()
         if cavy.Id == 0 then break end -- cavy is gone
         if distance(cavy.X, cavy.Z, trap.X, trap.Z ) < 5 then -- cavy is in trap
            printf("Cavy is in trap\n")
            memoryWriteInt(getProc(), player.Address + addresses.pawnTargetPtr_offset, cavy.Address);
            RoMScript("useSkill(1,1)"); yrest(50); RoMScript("useSkill(1,1)"); -- 'click' again to be sure
            yrest(2000);
            break
         end
         if player.Battling and (100*player.HP/player.MaxHP) < hpper then -- taking too much damage. fight
            player.IgnoreCavy = cavy.Address
            break
         end
         NewPos = CalcNewPos(trap, cavy)
         player:moveTo(NewPos, true)
         yrest(200)
         player:update()
      end
   end
end

function bankFull()
	bankID = charAttrGet("Bank");
	if bankID==0 then return end;
	Bank 		= math.floor (bankID/10)		  			--(first usable number of branch Bank)
	branchBank 	= (bankID-math.floor(bankID/10)*10)  		--(a-math.floor(a/b)*b) numbers of branch Bank
	local bankIndex = (Bank+branchBank-1)*40					-- last usable bank slot, is it full ?
	local texture, name, count, locked = RoMScript("GetBankItemInfo("..bankIndex..")");
	if count==nil then count=0 end;
	if not (count>=1)  then									-- if the bank is empty, there is nothing to move
		printf("\n  The Bank is empty \n ");
		return false
	else
		return true
	end
end

function ItemMoveToBank()
	local bankID = charAttrGet("Bank");						--every characters are different
	if bankID==0 then return end;
	local Bank 		= math.floor (bankID/10)				--(first usable branch Bank)
	local branchBank 	= (bankID-math.floor(bankID/10)*10) --(a-math.floor(a/b)*b) numbers of branch Bank
	local bankSlots	= branchBank*40				  			--(*40  in branch are 40 slot) number of slots
	RoMScript('OpenBank()');
	RoMScript('ShowUIPanel(BagFrame)');
	RoMScript('ShowUIPanel(BankFrame)');
    local startslot = 240;
    local finishslot =240-bankSlots;		
	printf("\n  bankID=  %s  \n ",bankID);
	printf("\n  First branch bank number=  %s  Branch Bank= %s Bank slots numbers= %s \n ", Bank,branchBank,bankSlots);
	printf("\n  START=  %s  Finish= %s \n ", startslot,finishslot);
	local i = startslot
	local MaxCella  =0
	local _Bank = "bank"..tostring(Bank)					-- first bank name E.g..:"bank2"
	local bankIndex = (Bank+branchBank-1)*40				-- last usable bank slot, is it full ?
	local tele = bankFull()
	if tele then printf("\n  The Bank are FULL \n "); end
	local k = bankIndex
	if not tele then
		printf("\n  I am moving in the bank \n ");
		printf("\n  START.. ");
		local allapot = i
		repeat
			local item = inventory.BagSlot[i];
			if i ==allapot-math.floor (bankSlots/10) then
				allapot = i;
				printf(".. ");
			elseif i==finishslot+1 then
				printf("FULL \n")
			end
			if ((not item.Empty) and item.Available) then
				item:pickup();
				RoMScript("PickupBankItem("..k..")");
				k=k-1;
				i=i-1;
			end;
		until  (i==finishslot)
	end;
	sendMacro("CloseBank()");
	sendMacro("CloseAllWindows()");
    	if not sendMacro('BagFrame:IsVisible()') then
		RoMScript("BagFrame:Show()");          
	end
end

function ItemMoveToBag()
	bankID = charAttrGet("Bank");
	if bankID==0 then return end;
	Bank 		= math.floor (bankID/10)		  			--(first usable branchBank)
	branchBank 	= (bankID-math.floor(bankID/10)*10)  		--(a-math.floor(a/b)*b) numbers of branchBanks
	bankSlots	= branchBank*40				  				--(*40  mert 1 fiok 40 cella) numbers of slots
	if not bankFull()  then									-- if the bank is empty, there is nothing to move
		printf("\n  A bank void \n ");
		return
	end
	RoMScript('OpenBank()');
	RoMScript('ShowUIPanel(BagFrame)');
	RoMScript('ShowUIPanel(BankFrame)');
	local finishslot=200
	if 		Bank ==1 then finishslot=0
	elseif	Bank ==2 then finishslot=40
	elseif	Bank ==3 then finishslot=80
	elseif	Bank ==4 then finishslot=120
	elseif	Bank ==5 then finishslot=160
	end
    local startslot  = finishslot+bankSlots;
	printf("\n  Numbers of first branchBank =  %s,  bankSlots= %s \n ", Bank,bankSlots);
	printf("\n  START=  %s  Finish= %s \n ", startslot,finishslot);
	local i = startslot
	printf("\n  START.. ");
	local allapot = i
	for i=startslot,finishslot,-1 do
		if i ==allapot-math.floor (bankSlots/10) then
			allapot = i;
			printf(".. ");
		elseif
			i==finishslot+1 then
			printf("FULL \n")
		end
		RoMScript("DrawBankItem("..i..")");
	end
	sendMacro("CloseBank()");
	sendMacro("CloseAllWindows()");
    	if not sendMacro('BagFrame:IsVisible()') then
		RoMScript("BagFrame:Show()");          
	end
end

function AUTOkill(_range)		-- it will be the PVP
   local height = 40
   local obj = nil
   local objectList = CObjectList();
   objectList:update();
   for k = 0,objectList:size() do
     	local obj = objectList:getObject(k);
     	if (  obj ~= nil and _range >= math.floor (distance(obj.X,obj.Z,player.X,player.Z))  and
			CPawn(obj.Address).Alive and obj.Address ~= player.Pet.Address  ) 	   then
			player:update();
			if height >= math.floor (math.abs(obj.Y-player.Y)) then
				printf("Target distance = %s     -------   ",math.floor (distance(obj.X,obj.Z,player.X,player.Z)) )
				printf("Target name= %s \n",obj.Name)
				--printf("Target X= %s,   Z= %s,  Y= %s \n",math.floor(obj.X),math.floor(obj.Z),math.floor(obj.Y))
				--printf("Player X= %s,   Z= %s,  Y= %s \n",math.floor(player.X),math.floor(player.Z),math.floor(player.Y))
				lookatTarget(obj.X,obj.Z,obj.Y);
				if player.Class1 == CLASS_SCOUT then
					ShadowUres();
					Shadow();
				end

				while CPawn(obj.Address).Alive do
					myKill();
					yrest(100);
				end
			end			 
		end
	end

end